Subject: Re: [nfsv4] NFS4ERR_DELAY for sequenced ops

From: "Haynes, Tom" <[email-masked]>
Date: Fri, 7 Sep 2012 20:15:34 +0000

So in 5661, LOCKU can return NFS4ERR_DELAY.

The proposal is to allow it to also return that error in 3530bis.

Any dissent?

On Aug 20, 2012, at 4:51 PM, "Karandikar, Asmita" <[email-masked]<mailto:[email-masked]>> wrote:

Sorry, I missed out LOCKU operation. I guess we are good with OPEN_CONFIRM. I don’t have a particular scenario in mind.

-Asmita

From: Myklebust, Trond
Sent: Monday, August 20, 2012 11:18 AM
To: Karandikar, Asmita; [email-masked]<mailto:[email-masked]>
Subject: RE: NFS4ERR_DELAY for sequenced ops

Hi Asmita,

NFS4ERR_DELAY is listed as a valid error for both OPEN, and CLOSE in RFC3530 (see sections 14.2.16 and 14.2.2).
draft-ietf-nfsv4-rfc3530bis-18.txt, also lists OPEN and CLOSE, and adds OPEN_DOWNGRADE in section 13.4.

So, the only missing operation would be OPEN_CONFIRM. Could you please explain why you’d need to return NFS4ERR_DELAY here? Why would you want to return ‘success’ to the OPEN call, but NFS4ERR_DELAY to the OPEN_CONFIRM?

Cheers
  Trond

From: [email-masked]<mailto:[email-masked]> [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of Karandikar, Asmita
Sent: Monday, August 20, 2012 2:05 PM
To: [email-masked]<mailto:[email-masked]>
Subject: [nfsv4] NFS4ERR_DELAY for sequenced ops

The 3530 RFC doesn't specify NFS4ERR_DELAY as a valid error for sequenced ops - OPEN, CLOSE, OPEN_CONFIRM and OPEN_DOWNGRADE.

In Data ONTAP, if we cannot process a request because we are waiting on some resource, we return back NFS4ERR_DELAY so that the client can come back and try.

NFS4ERR_DELAY not being an allowed error for these ops, we are forced to return NFS4ERR_RESOURCE which is not a transient error and results in the client returning an error to the application which is undesired.

I would like to get NFS4ERR_DELAY included as one of the allowable errors for sequenced ops.

We can add this in the 3530bis and 5661 errata. It should be ok to do so because the application will not see any change in behavior. The NFS client will retry on seeing NFS4ERR_DELAY. Also, this does not introduce any POSIX change.

-Asmita

_______________________________________________
nfsv4 mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/nfsv4